%define ipmitoolver 1.8.11
%define pythonver %(%{__python} -c "import sys; print sys.version[:3]")
Summary: OpenIPMI (Intelligent Platform Management Interface) library and tools
Name: OpenIPMI
Version: 2.0.16
Release: 11%{?dist}.2
License: GPL
Group: System Environment/Base
URL: http://sourceforge.net/projects/openipmi/
Source: http://prdownloads.sourceforge.net/openipmi/%{name}-%{version}.tar.gz
Source2: http://prdownloads.sourceforge.net/ipmitool/ipmitool-%{ipmitoolver}.tar.bz2
Source3: openipmi.sysconf
Source5: ipmievd.sysconf
Source6: rmcp.xinetd
Source7: openipmigui.desktop

Patch1: OpenIPMI-1.4.1-ipcmd-p-enhancement.patch
Patch2: OpenIPMI-2.0.6-man2.patch
Patch3: OpenIPMI-2.0.6-watchdog-init.patch
Patch4: OpenIPMI-2.0.18-pthread-pkgconfig.patch
Patch5: OpenIPMI-2.0.16-watchdog-init-2.patch

Patch100: ipmitool-1.8.10-k-option.patch
Patch101: ipmitool-1.8.10-manpage.patch
Patch102: ipmitool-1.8.10-user_enabled.patch
Patch103: ipmitool-1.8.11-man-fw.patch
Patch104: ipmitool-1.8.11-sensor-man.patch
Patch105: ipmitools-1.8.11-payload-status.patch
Patch106: ipmitool-1.8.11-runlevel.patch
Patch107: ipmitool-1.8.11-man-hpm.patch
Patch108: ipmitool-1.8.10-ipmievd-condrestart.patch
Patch109: ipmitool-1.8.11-man-noguard.patch
Patch110: ipmitool-1.8.11-sdr-elist-crash.patch
Patch111: ipmitool-1.8.11-sensor-15th-bit.patch
Patch112: ipmitool-1.8.11-sol-leak.patch
Patch113: ipmitool-1.8.11-sensor-missing-state.patch
Patch114: ipmitool-1.8.11-tsol-overflow.patch
Patch115: ipmitool-1.8.11-cmdline-checks.patch
Patch116: ipmitool-1.8.11-sol-cmdline.patch
Patch117: ipmitool-1.8.11-password-message.patch
Patch118: ipmitool-1.8.11-dont-enable-ipmi.patch
Patch119: ipmitool-1.8.11-dell-oem.patch
Patch120: ipmitool-1.8.11-set-kg-key.patch
Patch121: ipmitool-1.8.11-set-kg-key2.patch
Patch122: ipmitool-1.8.11-ipmb-address.patch
Patch123: ipmitool-1.8.11-sensor-crash.patch
Patch124: ipmitool-1.8.11-ipmb-bridge.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: %{name}-libs = %{version}-%{release}
PreReq: chkconfig
BuildPrereq: gdbm-devel swig glib2-devel net-snmp-devel ncurses-devel
BuildPrereq: openssl-devel python-devel readline-devel tcl-devel tkinter
BuildPrereq: desktop-file-utils

%description
The Open IPMI project aims to develop an open code base to allow access to
platform information using Intelligent Platform Management Interface (IPMI).
This package contains the tools of the OpenIPMI project.

%package libs
Group: Development/Libraries
Summary: The OpenIPMI runtime libraries

%description libs
The OpenIPMI-libs package contains the runtime libraries for shared binaries
and applications.

%package tools
Group: Applications/System
Summary: OpenIPMI utilities and scripts from ipmitool
Provides: ipmitool = %{ipmitoolver}-%{release}

%description tools
The OpenIPMI-tools package contains the addon utilities and script from the
ipmitool project.

%package perl
Group: Development/Libraries
Summary: OpenIPMI Perl language bindings
Requires: %{name}-libs = %{version}-%{release}

%description perl
The OpenIPMI-perl package contains the Perl language bindings for OpenIPMI.

%package python
Group: Development/Libraries
Summary: OpenIPMI Python language bindings
Requires: %{name}-libs = %{version}-%{release}

%description python
The OpenIPMI-python package contains the Python language bindings for OpenIPMI.

%package devel
Group: Development/Libraries
Summary: The development environment for the OpenIPMI project.
Requires: %{name}-libs = %{version}-%{release}

%description devel
The OpenIPMI-devel package contains the development libraries and header files
of the OpenIPMI project.

%package gui
Group: System Environment/Base
Summary: IPMI graphical user interface tool
Requires: tix tkinter %{name}-python = %{version}-%{release}

%description gui
The OpenIPMI-gui package contains the graphical user interface to monitor
and control IPMI-enabled devices.


%prep
%setup -q -a 2
%patch1 -p1 -b .ipcmd-p-enhancement
%patch2 -p1 -b .man2
%patch3 -p1 -b .watchdog-init
%patch4 -p1 -b .pkgconfig-threads
%patch5 -p1 -b .watchdog-init-2

pushd ipmitool-%{ipmitoolver}
%patch100 -p1 -b .k-enhancement
%patch101 -p1 -b .manpage
%patch102 -p1 -b .user_enabled
%patch103 -p1 -b .man-fw
%patch104 -p1 -b .man-sensor
%patch105 -p1 -b .sensor-status
%patch106 -p1
%patch107 -p1 -b .hpm
%patch108 -p0
%patch109 -p1 -b .noguard
%patch110 -p1 -b .sdr-elist-crash
%patch111 -p1 -b .sensor-15th-bit
%patch112 -p1 -b .sol-leak
%patch113 -p1 -b .sensor-missing-state
%patch114 -p1 -b .tsol-overflow
%patch115 -p1 -b .cmdline-checks
%patch116 -p1 -b .sol-cmdline
%patch117 -p1 -b .password-message
%patch118 -p1 -b .dont-enable-ipmi
%patch119 -p1
%patch120 -p1 -b .set-kg-key
%patch121 -p1 -b .set-kg-key2
%patch122 -p1 -b .ipmb-address
%patch123 -p1 -b .sensors-crash
%patch124 -p1 -b .ipmb-bridge
popd

%build
%configure --with-pythoninstall=%{_libdir}/python%{pythonver}/site-packages

# disable rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

make
pushd ipmitool-%{ipmitoolver}
%configure
make 
popd

%install
rm -rf ${RPM_BUILD_ROOT} 
make install DESTDIR=$RPM_BUILD_ROOT
rm -rf $RPM_BUILD_ROOT/%{_libdir}/*.la
# Remove python cruft in 32bit libdir on 64bit archs...
%ifarch ppc64 s390x x86_64
rm -rf $RPM_BUILD_ROOT/usr/lib
%endif
pushd ipmitool-%{ipmitoolver}
make install DESTDIR=${RPM_BUILD_ROOT}
install -d ${RPM_BUILD_ROOT}%{_datadir}/ipmitool/
cp -a contrib/* ${RPM_BUILD_ROOT}%{_datadir}/ipmitool/
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/ipmitool/Makefile*
popd

install -d ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
install -m 644 %SOURCE3 ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/ipmi
install -d ${RPM_BUILD_ROOT}%{_initrddir}
install -m 755 ipmi.init ${RPM_BUILD_ROOT}%{_initrddir}/ipmi

install -m 644 %SOURCE5 ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/ipmievd
install -m 755 ipmitool-%{ipmitoolver}/contrib/ipmievd.init.redhat ${RPM_BUILD_ROOT}%{_initrddir}/ipmievd


install -d ${RPM_BUILD_ROOT}%{_sysconfdir}/xinetd.d
install -m 644 %SOURCE6 ${RPM_BUILD_ROOT}%{_sysconfdir}/xinetd.d/rmcp

desktop-file-install --vendor="redhat" --dir=${RPM_BUILD_ROOT}%{_datadir}/applications %{SOURCE7}

%post
/sbin/chkconfig --add ipmi

%post tools
/sbin/chkconfig --add ipmievd

%preun
if [ $1 = 0 ]; then
   service ipmi stop >/dev/null 2>&1
   /sbin/chkconfig --del ipmi
fi

%preun tools
if [ $1 = 0 ]; then
   service ipmievd stop >/dev/null 2>&1
   /sbin/chkconfig --del ipmievd
fi

%postun
if [ "$1" -ge "1" ]; then
    service ipmi condrestart >/dev/null 2>&1 || :
fi

%postun tools
if [ "$1" -ge "1" ]; then
    service ipmievd condrestart >/dev/null 2>&1 || :
fi

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/sysconfig/ipmi
%config(noreplace) %{_sysconfdir}/xinetd.d/rmcp
%config %{_initrddir}/ipmi
%doc COPYING FAQ README README.Force README.MotorolaMXP
%{_bindir}/ipmicmd
%{_bindir}/ipmilan
%{_bindir}/ipmish
%{_bindir}/ipmi_ui
%{_bindir}/openipmicmd
%{_bindir}/openipmish
%{_bindir}/rmcp_ping
%{_bindir}/solterm
%{_mandir}/man1/ipmi_ui*
%{_mandir}/man1/openipmicmd*
%{_mandir}/man1/openipmigui*
%{_mandir}/man1/openipmish*
%{_mandir}/man1/rmcp_ping*
%{_mandir}/man1/solterm*
%{_mandir}/man7/ipmi_cmdlang*
%{_mandir}/man7/openipmi_conparms*
%{_mandir}/man8/ipmilan*

%files perl
%{_libdir}/perl5/*_perl/*/*-linux-thread-multi/OpenIPMI.pm
%dir %{_libdir}/perl5/*_perl/*/*-linux-thread-multi/auto/OpenIPMI
%{_libdir}/perl5/*_perl/*/*-linux-thread-multi/auto/OpenIPMI/*

%files gui
%defattr(-,root,root)
%{_bindir}/openipmigui
%{_mandir}/man1/openipmigui*
%{_libdir}/python*/site-packages/openipmigui
%{_datadir}/applications/redhat-openipmigui.desktop

%files python
%{_libdir}/python*/site-packages/*OpenIPMI*

%files tools
%defattr(-,root,root)
%{_datadir}/doc/ipmitool/
%{_datadir}/ipmitool/
%{_bindir}/ipmitool
%{_mandir}/man1/ipmitool*
%{_mandir}/man8/ipmievd*
/usr/sbin/ipmievd
%config(noreplace) %{_sysconfdir}/sysconfig/ipmievd
%config %{_initrddir}/ipmievd

%files libs
%defattr(-,root,root)
%{_libdir}/*.so.*
%{_libdir}/pkgconfig/*

%files devel
%defattr(-,root,root)
%{_includedir}/OpenIPMI
%{_libdir}/*.so
%{_libdir}/*.a

%changelog
* Mon Jul 25 2011 Jan Safranek <jsafrane@redhat.com> 2.0.16-11.el5.2
- rebuilt for 5.7.z

* Fri Jul 15 2011 Jan Safranek <jsafrane@redhat.com> 2.0.16-11.el5.1
- ipmitool: disabled automatic bridging of SDR readings to IPMB
  (#722462)

* Wed Dec  1 2010 Jan Safranek <jsafrane@redhat.com> 2.0.16-11.el5
- ipmitool: fixed 'delloem mac' command on big-endian systems (#568676)

* Wed Nov 24 2010 Jan Safranek <jsafrane@redhat.com> 2.0.16-10.el5
- ipmitool: fixed Kg encryption key setting broken in previous version
  (#656841)

* Fri Sep 24 2010 Jan Safranek <jsafrane@redhat.com> 2.0.16-9.el5
- ipmitool: fixed crash when processing non-standard sensor readings (#550120)

* Fri Sep 17 2010 Jan Safranek <jsafrane@redhat.com> 2.0.16-8.el5
- fixed OpenIPMI pkgconfig file to include -pthreads when needed (#591646)
- fixed impi service exit codes, 'service ipmi start' now succeeds if the
  service is already started (#619143)
- ipmitool: fixed crash when receiving error instead of sensor data (#580087)
- ipmitool: properly ignore a bit in sensor event state (#616546)
- ipmitool: fixed a memory leak on receiving SOL ack (#616546)
- ipmitol: fixed reading of sensor state if the BMC provides only part of it
  (#541263)
- ipmitool: fixed buffer overflow in tsol module (#546386)
- ipmitool: fixed checking of several command line arguments (#514218 #514237)
- ipmitool: improved error message when wrong user/password is supplied (#552458)
- ipmitool: fixed 'user priv' command, now it does not enable IPMI messaging by
  default (#552459)
- ipmitool: added 'delloem' command for Dell-specific IPMI extensions (#568676)
- ipmitool: added 'channel setkg' command to set Kg encryption key (#503039)
- ipmitool: added detection of local IPMB address, messages to BMC won't be
  unnecessarily tunneled (#636854)

* Wed Nov 11 2009 Jan Safranek <jsafrane@redhat.com> 2.0.16-7.el5
- recompile to fix rpmdiff complaints

* Wed Nov 11 2009 Jan Safranek <jsafrane@redhat.com> 2.0.16-6.el5
- relax the depencency on xinetd, sample xinetd service can be installed
  without it (#522524)
- describe hpm and fwum commands in ipmitool man page (#514215)
- fix condrestart action of ipmievd init script (#532445)
- report failure of watchdog startup (#514678)
- enhance description of sol set command to cover noguard parameter (#513609)

* Fri Jul 17 2009 Jan Safranek <jsafrane@redhat.com> 2.0.16-5.el5
- fix crash on "ipmitool sol payload status" command without
  /dev/ipmi device (#470031)
- fix ipmievd init script, it's off by default now (#509490)

* Wed Jun 10 2009 Jan Safranek <jsafrane@redhat.com> 2.0.16-4.el5
- fix content of -python and -gui subpackages

* Wed Jun 10 2009 Jan Safranek <jsafrane@redhat.com> 2.0.16-3.el5
- introduce new subpackage with openipmigui tool (#504783)

* Fri Apr 24 2009 Jan Safranek <jsafrane@redhat.com> 2.0.16-2.el5
- Added description of 'ipmitool sensor list' output to man page
  (#479702)

* Fri Feb 27 2009 Jan Safranek <jsafrane@redhat.com> 2.0.16-1.el5
- Rebased to OpenIPMI-2.0.16 (#475542)
- Fixed sporadic crash when connecting using 'ipmicmd lan' (#437013)
- Added command-line checks to rmcp_ping (#437256)
- Removed wrong RPATH from compiled binaries (#466119)
- Removed duplicate man pages from OpenIPMI-devel package (#466487)
- Package documentation files
- Provide sample xinetd service which blocks RMCP port so portmap and other
  random-port-using services can't bind to it (#429329)
- ipmitool updated to version 1.8.11 (#475542)
- Added ipmievd init script and sysconfig file (#469979)
- Added Provides: ipmitool to OpenIPMI-tools (#442784)
- Added documentation of 'fwum' and 'hpm' commands to ipmitool man page
  (#438539)

* Fri Oct 31 2008 Jan Safranek <jsafrane@redhat.com> 2.0.6-11.el5
- Fixed crash when parsing 'ipmitool tsol' command line arguments (#437271)

* Wed Oct 29 2008 Jan Safranek <jsafrane@redhat.com> 2.0.6-10.el5
- Fixed crash when parsing 'ipmitool sol' command line arguments (#466893)

* Tue Oct 07 2008 Phil Knirsch <pknirsch@redhat.com> 2.0.6-9.el5
- Added missing requires for subpackages (#464102)
- Resolves: #464102

* Mon Sep 15 2008 Phil Knirsch <pknirsch@redhat.com> 2.0.6-8.el5
- Add support for Pigeon Point BMC (#349551)
- Added enabled user status to user list command (#430306)
- Fixed several manpage typos (#437020,#437021,#437026)
- Update to ipmitool-1.8.10 (#439557)

* Thu Sep 11 2008 Phil Knirsch <pknirsch@redhat.com> 2.0.6-7.el5
- Fix for SEL buffer full problem (#456240)

* Tue Jan 15 2008 Phil Knirsch <pknirsch@redhat.com> - 2.0.6-6.el5
- Added 2 missing commands to the manpage (#242402, #242403)

* Fri Jan 11 2008 Phil Knirsch <pknirsch@redhat.com> - 2.0.6-5.el5.5
- Added -K option for ipmitool to hide keyword from cmdline (#238970)
- Added -p option for ipmicmd to hide password from cmdline (#239186)
- Fixed OpenIPMI-python package description (#314031)

* Thu Jun 21 2007 Phil Knirsch <pknirsch@redhat.com> - 2.0.6-5.el5.4
- Update ipmitool to 1.8.9 (#228114)

* Wed Dec 13 2006 Phil Knirsch <pknirsch@redhat.com> - 2.0.6-5.el5.3
- Fixed ipmitool fru print displays error for physical fru devices (#217676)

* Tue Nov 21 2006 Phil Knirsch <pknirsch@redhat.com> - 2.0.6-5.el5.2
- Added patch to fix sensors problems on Woodcrest (#214309)

* Wed Oct 25 2006 Phil Knirsch <pknirsch@redhat.com>
- Bump release to trigger build on ia64, too (#211313)

* Tue Jul 18 2006 Phil Knirsch <pknirsch@redhat.com> - 2.0.6-5
- Fixed check for udev in initscript (#197956)

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 2.0.6-4.1
- rebuild

* Fri Jun 16 2006 Bill Nottingham <notting@redhat.com> 2.0.6-4
- don't include <linux/compiler.h>

* Fri Jun 16 2006 Jon Masters <jcm@redhat.com> 2.0.6-3
- Fix a build requires (needs glibc-kernheaders)

* Thu Jun 15 2006 Jesse Keating <jkeating@redhat.com> 2.0.6-2
- Bump for new glib2

* Tue May 16 2006 Phil Knirsch <pknirsch@redhat.com> 2.0.6-1
- Fixed bug with type conversion in ipmitool (#191091)
- Added python bindings 
- Split off perl and python bindings in separate subpackages
- Dropped obsolete patches
- Added missing buildprereq on readline-devel
- Made it install the python bindings properly on 64bit archs

* Mon May 15 2006 Phil Knirsch <pknirsch@redhat.com>
- Updated ipmitool to 1.8.8
- Updated OpenIPMI to 2.0.6

* Fri Feb 17 2006 Phil Knirsch <pknirsch@redhat.com> 1.4.14-19
- Added missing PreReq for chkconfig

* Mon Feb 13 2006 Jesse Keating <jkeating@redhat.com> - 1.4.14-18.2.1
- rebump for build order issues during double-long bump

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 1.4.14-18.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 1.4.14-18.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Mon Feb 06 2006 Phil Knirsch <pknirsch@redhat.com> 1.4.14-18
- Updated ipmitool to latest upstream version.
- Removed 3 patches for already fixed bugs in latest ipmitool.
- Adapted warning message fix for ipmitool for latest version.

* Tue Jan 24 2006 Phil Knirsch <pknirsch@redhat.com> 1.4.14-17
- Fixed some minor things in initscripts.

* Mon Jan 09 2006 Phil Knirsch <pknirsch@redhat.com> 1.4.14-16
- Included FRU fix for displaying FRUs with ipmitool
- Included patch for new option to specify a BMC password for IPMI 2.0 sessions

* Tue Jan 03 2006 Radek Vokal <rvokal@redhat.com> 1.4.14-15
- Rebuilt against new libnetsnmp

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Wed Nov 23 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-14
- Some more initscript and sysconfig updates from Dell.

* Wed Nov 09 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-13
- Rebuilt to link against latest openssl libs.
- Fixed ipmitool not setting session privilege level (#172312)

* Wed Nov 02 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-11
- Rebuild to link against new net-snmp libs.

* Tue Oct 11 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-10
- Updated initscript to fix missing redhat-lsb bug (#169901)

* Thu Sep 08 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-9
- Another update to latest initscripts from Dell
- Fixed some missing return statements for non-void functions (#164138)

* Thu Sep 01 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-8
- Updated initscript to latest version from Dell

* Fri Aug 12 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-7
- Fixed the unwanted output of failed module loading of the initscript. Behaves
  now like all our other initscripts (#165476)

* Fri Aug 05 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-6
- Fixed build problem on 64bit machines

* Fri Jul 15 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-5
- Fixed missing change to not autostart in the initscript

* Wed Jul 06 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-4
- Made the initscript a replacing configfile

* Mon Jul 04 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-3
- Updated versions of the initscripts and sysconf files
- Fixed typo in preun script and changelog

* Mon Jun 27 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.14-2
- Updated to OpenIPMI-1.4.14
- Split the main package into normal and libs package for multilib support
- Added ipmitool-1.8.2 to OpenIPMI and put it in tools package
- Added sysconf and initscript (#158270)
- Fixed oob subscripts (#149142)

* Wed Mar 30 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.11-5
- Correctly put libs in the proper packages

* Thu Mar 17 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.11-4
- gcc4 rebuild fixes
- Added missing gdbm-devel buildprereq

* Wed Mar 02 2005 Phil Knirsch <pknirsch@redhat.com> 1.4.11-3
- bump release and rebuild with gcc 4

* Tue Feb 08 2005 Karsten Hopp <karsten@redhat.de> 1.4.11-2 
- update

* Tue Oct 26 2004 Phil Knirsch <pknirsch@redhat.com>
- Initial version
